# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2018_07_01
  module Models
    #
    # Describes all the properties for encoding a video with the H.264 codec.
    #
    class H264Video < Video

      include MsRestAzure


      def initialize
        @odatatype = "#Microsoft.Media.H264Video"
      end

      attr_accessor :odatatype

      # @return [Boolean] Whether or not the encoder should insert key frames
      # at scene changes. If not specified, the default is false. This flag
      # should be set to true only when the encoder is being configured to
      # produce a single output video.
      attr_accessor :scene_change_detection

      # @return [H264Complexity] Tells the encoder how to choose its encoding
      # settings. The default value is Balanced. Possible values include:
      # 'Speed', 'Balanced', 'Quality'
      attr_accessor :complexity

      # @return [Array<H264Layer>] The collection of output H.264 layers to be
      # produced by the encoder.
      attr_accessor :layers


      #
      # Mapper for H264Video class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: '#Microsoft.Media.H264Video',
          type: {
            name: 'Composite',
            class_name: 'H264Video',
            model_properties: {
              label: {
                client_side_validation: true,
                required: false,
                serialized_name: 'label',
                type: {
                  name: 'String'
                }
              },
              odatatype: {
                client_side_validation: true,
                required: true,
                serialized_name: '@odata\\.type',
                type: {
                  name: 'String'
                }
              },
              key_frame_interval: {
                client_side_validation: true,
                required: false,
                serialized_name: 'keyFrameInterval',
                type: {
                  name: 'TimeSpan'
                }
              },
              stretch_mode: {
                client_side_validation: true,
                required: false,
                serialized_name: 'stretchMode',
                type: {
                  name: 'String'
                }
              },
              scene_change_detection: {
                client_side_validation: true,
                required: false,
                serialized_name: 'sceneChangeDetection',
                type: {
                  name: 'Boolean'
                }
              },
              complexity: {
                client_side_validation: true,
                required: false,
                serialized_name: 'complexity',
                type: {
                  name: 'String'
                }
              },
              layers: {
                client_side_validation: true,
                required: false,
                serialized_name: 'layers',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'H264LayerElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'H264Layer'
                      }
                  }
                }
              }
            }
          }
        }
      end
    end
  end
end
