# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2018_07_01
  module Models
    #
    # The Live Event preview.
    #
    class LiveEventPreview

      include MsRestAzure

      # @return [Array<LiveEventEndpoint>] The endpoints for preview.
      attr_accessor :endpoints

      # @return [LiveEventPreviewAccessControl] The access control for
      # LiveEvent preview.
      attr_accessor :access_control

      # @return [String] The identifier of the preview locator in Guid format.
      # Specifying this at creation time allows the caller to know the preview
      # locator url before the event is created.  If omitted, the service will
      # generate a random identifier.  This value cannot be updated once the
      # live event is created.
      attr_accessor :preview_locator

      # @return [String] The name of streaming policy used for the LiveEvent
      # preview.  This value is specified at creation time and cannot be
      # updated.
      attr_accessor :streaming_policy_name

      # @return [String] An Alternative Media Identifier associated with the
      # StreamingLocator created for the preview.  This value is specified at
      # creation time and cannot be updated.  The identifier can be used in the
      # CustomLicenseAcquisitionUrlTemplate or the
      # CustomKeyAcquisitionUrlTemplate of the StreamingPolicy specified in the
      # StreamingPolicyName field.
      attr_accessor :alternative_media_id


      #
      # Mapper for LiveEventPreview class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'LiveEventPreview',
          type: {
            name: 'Composite',
            class_name: 'LiveEventPreview',
            model_properties: {
              endpoints: {
                client_side_validation: true,
                required: false,
                serialized_name: 'endpoints',
                type: {
                  name: 'Sequence',
                  element: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'LiveEventEndpointElementType',
                      type: {
                        name: 'Composite',
                        class_name: 'LiveEventEndpoint'
                      }
                  }
                }
              },
              access_control: {
                client_side_validation: true,
                required: false,
                serialized_name: 'accessControl',
                type: {
                  name: 'Composite',
                  class_name: 'LiveEventPreviewAccessControl'
                }
              },
              preview_locator: {
                client_side_validation: true,
                required: false,
                serialized_name: 'previewLocator',
                type: {
                  name: 'String'
                }
              },
              streaming_policy_name: {
                client_side_validation: true,
                required: false,
                serialized_name: 'streamingPolicyName',
                type: {
                  name: 'String'
                }
              },
              alternative_media_id: {
                client_side_validation: true,
                required: false,
                serialized_name: 'alternativeMediaId',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
