# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2018_07_01
  module Models
    #
    # A video analyzer preset that extracts insights (rich metadata) from both
    # audio and video, and outputs a JSON format file.
    #
    class VideoAnalyzerPreset < AudioAnalyzerPreset

      include MsRestAzure


      def initialize
        @odatatype = "#Microsoft.Media.VideoAnalyzerPreset"
      end

      attr_accessor :odatatype

      # @return [InsightsType] Defines the type of insights that you want the
      # service to generate. The allowed values are 'AudioInsightsOnly',
      # 'VideoInsightsOnly', and 'AllInsights'. The default is AllInsights. If
      # you set this to AllInsights and the input is audio only, then only
      # audio insights are generated. Similarly if the input is video only,
      # then only video insights are generated. It is recommended that you not
      # use AudioInsightsOnly if you expect some of your inputs to be video
      # only; or use VideoInsightsOnly if you expect some of your inputs to be
      # audio only. Your Jobs in such conditions would error out. Possible
      # values include: 'AudioInsightsOnly', 'VideoInsightsOnly', 'AllInsights'
      attr_accessor :insights_to_extract


      #
      # Mapper for VideoAnalyzerPreset class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: '#Microsoft.Media.VideoAnalyzerPreset',
          type: {
            name: 'Composite',
            class_name: 'VideoAnalyzerPreset',
            model_properties: {
              odatatype: {
                client_side_validation: true,
                required: true,
                serialized_name: '@odata\\.type',
                type: {
                  name: 'String'
                }
              },
              audio_language: {
                client_side_validation: true,
                required: false,
                serialized_name: 'audioLanguage',
                type: {
                  name: 'String'
                }
              },
              experimental_options: {
                client_side_validation: true,
                required: false,
                serialized_name: 'experimentalOptions',
                type: {
                  name: 'Dictionary',
                  value: {
                      client_side_validation: true,
                      required: false,
                      serialized_name: 'StringElementType',
                      type: {
                        name: 'String'
                      }
                  }
                }
              },
              insights_to_extract: {
                client_side_validation: true,
                required: false,
                serialized_name: 'insightsToExtract',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
