# encoding: utf-8
# Code generated by Microsoft (R) AutoRest Code Generator.
# Changes may cause incorrect behavior and will be lost if the code is
# regenerated.

module Azure::MediaServices::Mgmt::V2019_05_01_preview
  module Models
    #
    # Properties of the Streaming Locator.
    #
    class AssetStreamingLocator

      include MsRestAzure

      # @return [String] Streaming Locator name.
      attr_accessor :name

      # @return [String] Asset Name.
      attr_accessor :asset_name

      # @return [DateTime] The creation time of the Streaming Locator.
      attr_accessor :created

      # @return [DateTime] The start time of the Streaming Locator.
      attr_accessor :start_time

      # @return [DateTime] The end time of the Streaming Locator.
      attr_accessor :end_time

      # @return StreamingLocatorId of the Streaming Locator.
      attr_accessor :streaming_locator_id

      # @return [String] Name of the Streaming Policy used by this Streaming
      # Locator.
      attr_accessor :streaming_policy_name

      # @return [String] Name of the default ContentKeyPolicy used by this
      # Streaming Locator.
      attr_accessor :default_content_key_policy_name


      #
      # Mapper for AssetStreamingLocator class as Ruby Hash.
      # This will be used for serialization/deserialization.
      #
      def self.mapper()
        {
          client_side_validation: true,
          required: false,
          serialized_name: 'AssetStreamingLocator',
          type: {
            name: 'Composite',
            class_name: 'AssetStreamingLocator',
            model_properties: {
              name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'name',
                type: {
                  name: 'String'
                }
              },
              asset_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'assetName',
                type: {
                  name: 'String'
                }
              },
              created: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'created',
                type: {
                  name: 'DateTime'
                }
              },
              start_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'startTime',
                type: {
                  name: 'DateTime'
                }
              },
              end_time: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'endTime',
                type: {
                  name: 'DateTime'
                }
              },
              streaming_locator_id: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'streamingLocatorId',
                type: {
                  name: 'String'
                }
              },
              streaming_policy_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'streamingPolicyName',
                type: {
                  name: 'String'
                }
              },
              default_content_key_policy_name: {
                client_side_validation: true,
                required: false,
                read_only: true,
                serialized_name: 'defaultContentKeyPolicyName',
                type: {
                  name: 'String'
                }
              }
            }
          }
        }
      end
    end
  end
end
